{$APPTYPE CONSOLE}
{$Q+,R+}

uses
  SysUtils;

var
  len: array[1..100] of integer;
  n, l, a, b: integer;
  x, sum: integer;
  i: integer;
  fin, fout, fans: text;
  zero: boolean;

  procedure Ex(s: string; ec: integer);
  begin
    write(s);
    try
      close(fin);
      close(fout);
      close(fans);
    except
    end;
    halt(ec);
  end;

begin
   try
     assign(fin, paramstr(1)); reset(fin);
   except on e: Exception do
     Ex('Error opening input: ' + e.Message, 3);
   end;
   try
     assign(fans, paramstr(3)); reset(fans);
   except on e: Exception do
     Ex('Error opening answer: ' + e.Message, 3);
   end;
   try
     assign(fout, paramstr(2)); reset(fout);
   except on e: Exception do
     Ex('Can''t open output: ' + e.Message, 2);
   end;

   read(fin, n, l, a, b);

   try
     assert(not SeekEof(fout));
     read(fout, x);
     if (x = 0) then
     begin
       zero := true;
       assert(SeekEof(fout));
     end
     else
     begin
       zero := false;
       len[1] := x;
       for i := 2 to n do
       begin
         assert(not SeekEof(fout));
         read(fout, len[i]);
       end;
       assert(SeekEof(fout));
     end;
   except
     Ex('PE', 2);
   end;

   if ((n*a <= l) and (l <= n*b)) then
   begin
     if (zero) then
       Ex('Solution exists but output is 0', 1);
     for i := 1 to n do
     begin
       if (not ((len[i] >= a) and (len[i] <= b))) then
         Ex('Length of a napkin is not from a to b', 1);
     end;
     sum := 0;
     for i := 1 to n do
       sum := sum + len[i];
     if (sum <> l) then
       Ex('Sum of lengths of napkins doesn''t equal L', 1);
   end
   else
   begin
     if (not zero) then
       Ex('Solution doesn''t exist but output isn''t 0', 1);
   end;

   Ex('', 0);
end.
